
#include <upf/upf.h>
#include <iostream>
#include "ICalculator.h"
#include "IPrinter.h"

using namespace std;
using namespace upf;


void calculate()
{
    Ptr<ICalculator> calc = upf::create("Calculator");
    Ptr<IPrinter> prn = upf::create("Printer");
    
    cout << "Calculating something w/o printer: " << calc->add(10, 3) << endl;
    calc->setPrinter(prn);
    cout << "Calculating w/ printer: " << calc->add(10, 3) << endl;
    calc = upf::create("BrokenCalculator");
    calc->setPrinter(prn);
    cout << "Wrongly calculating w/ printer: " << calc->add(10, 3) << endl;
}


void setupPaths()
{
    Ptr<IManager> mng = upf::getManager();
    mng->addModulesPath(".");
#ifdef __UPF_UNIX__
    mng->addModulesPath("./.libs"); // to make libtool happy
#endif
}


int main()
{
    upf::init();
    setupPaths();

    calculate();

    upf::done();
}
