
// Note: it is better to define this on command line, e.g. with pkg-config and upf-module
//       module
#define UPF_BUILDING_MODULE

#include <upf/upf.h>
#include "ICalculator.h"


class Calculator : public ICalculator
{
public:
    void setPrinter(IPrinter *printer)
    {
        m_printer = printer; 
    }
    long add(long a, long b)
    {
        long c = a + b;
        if (m_printer)
        {
            char buf[512];
            sprintf(buf, "Calculator: %li + %li = %li", a, b, c);
            m_printer->print(buf);
        }
        return c;
    }

private:
    upf::Ptr<IPrinter> m_printer;
    
    UPF_DECLARE_CLASS(Calculator)
};

UPF_IMPLEMENT_CLASS(Calculator)
{
    UPF_INTERFACE(ICalculator)
}


class BrokenCalculator : public ICalculator
{
public:
    void setPrinter(IPrinter *printer)
    {
        m_printer = printer; 
    }
    long add(long a, long b)
    {
        long c = ((a + b) / 2) * 2;
        if (m_printer)
        {
            char buf[512];
            sprintf(buf, "BrokenCalculator: %li + %li = %li", a, b, c);
            m_printer->print(buf);
        }
        return c;
    }

private:
    upf::Ptr<IPrinter> m_printer;
    
    UPF_DECLARE_CLASS(BrokenCalculator)
};

UPF_IMPLEMENT_CLASS(BrokenCalculator)
{
    UPF_INTERFACE(ICalculator)
}

UPF_DLL_MODULE()
{
    UPF_EXPORTED_CLASS(Calculator)
    UPF_EXPORTED_CLASS(BrokenCalculator)
}
