#ifndef __UPF_CXX_AFTER_IOBJECT_H__
#define __UPF_CXX_AFTER_IOBJECT_H__

namespace upf {

// NB: this is yet another dirty hack. We don't need to make this function
//     a template because we will only use it for T=upf_Object. But it can't
//     be regular inlined function because calling convention can't be specified
//     for inline functions in win32 compilers. The function can't be non-inline,
//     either, because gcc would require implementation file then and we want to
//     avoid having to link against C++ library at any cost because of binary
//     incompability.
template<typename T> 
void _UPF_CALLING_CONVENTION _CxxABIQueryInterface(T *object, const upf_IID *iid,
                                                   upf_InterfaceData *retval)
{
    *retval = (static_cast<IObject*>(object->data))->queryInterface(*iid);
}


/** \internal
    Queries the object for given interface. 
    \note Use upf::Ptr instead of directly calling this function.
    \return pointer to interface implementation or NULL if the object does not
            provide this interface.
 */
template<class T> inline T* queryInterface(IObject *obj)
{
    if (obj == NULL)
        return NULL;
    else
    {
        InterfacePtr i = obj->queryInterface(InterfaceTraits<T>::iid());
        upf_Object *abi = obj->_upf_getABIObject();
        if (abi->nativeContext == upf_context)
        {
            return reinterpret_cast<T*>(i.data);
        }
        else
        {
            if (i.data == NULL)
                return NULL;
            else
                return new Proxy<T>(abi, i);
        }
    }
}


}; // end of namespace 'upf'


#endif
