
#include <stdlib.h>

#include "upf/upf.h"
#include "private.h"

#undef upf_context
upf_ContextID upf_context = 0;
upf_ContextID __upf_internal_context = 0;

namespace upf { namespace impl {


void init_std_contexts(const char *user_context)
{
    __upf_internal_context = get_context(UPF_RUNTIME_CONTEXT);
    upf_context = get_context(user_context);
}

upf_ContextID get_context(const char *context_string)
{
    static upf_ContextID firstFree = 1;
    upf_ContextID ctx;
    
    if (context_string == NULL)
        ctx = firstFree++;  
    else
    {
        StringHash<upf_ContextID>::iterator entry = privateData->contexts.find(context_string);
        if (entry == privateData->contexts.end())
        {
            ctx = firstFree++;
            privateData->contexts[context_string] = ctx;
        }
        else
            ctx = entry->second;
    }
    
    return ctx;
}


} }
