
#ifndef __UPF_DLL_LOADER_H__
#define __UPF_DLL_LOADER_H__

#include "upf/upf.h"
#include "upf/ILoader.h"

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __UPF_WIN32__
#include <windows.h>
#endif

#include <vector>

namespace upf { namespace impl {

using namespace std;

class DllModule
{
public:
    virtual bool load(const string& filename);
    virtual void *getSymbol(const string& name);
    virtual void unload();

private:
#ifdef __UPF_WIN32__
    typedef HMODULE dll_t;
#endif
#ifdef __UPF_UNIX__
    typedef void* dll_t;
#endif
    dll_t m_handle;
};


class DllLoader : public ILoader
{
public:
    DllLoader();
    virtual ~DllLoader();
    ExtensionsList getExtensions();
    bool load(const string& filename);
    bool canLoad(const string& filename);
    string getDescription();

private:
    typedef vector<DllModule> ModulesList;
    ModulesList m_modules;

    UPF_DECLARE_CLASS(DllLoader)
};


} } // end of namespace

#endif
