
#include <iostream>
#include "upf/upf.h"
#include "private.h"

namespace upf { namespace impl {

void DefaultLog::log(const string& origin, const LogType& type, const string& text)
{
    switch (type)
    {
        case LOG_INFO:
            cout << text << endl;
            break;
        case LOG_WARNING:
            cerr << "Warning: " << text << endl;
            break;
        case LOG_ERROR:
            cerr << "Error: " << text << endl;
            break;
    }
}

void LogChangeListener::onChange(const string&, IObject* value)
{
    privateData->log = value;
}


} }


UPF_IMPLEMENT_CLASS(upf::impl::DefaultLog)
{
    UPF_INTERFACE(upf::ILog)
}

UPF_IMPLEMENT_CLASS(upf::impl::LogChangeListener)
{
    UPF_INTERFACE(upf::IServiceChangeListener)
}
