
#include <stdlib.h>

#include "upf/upf.h"
#include "private.h"

namespace upf { namespace impl {

void marchaller_init(upf_Arguments *args)
{
    assert(args != NULL);

    args->chunkPos = 0;
    args->totalPos = 0;
    args->currChunk = &args->data;
    args->size = 0;
    args->data.next = NULL;
}

void marchaller_seek0(upf_Arguments *args)
{
    assert(args != NULL);

    args->totalPos = 0;
    args->chunkPos = 0;
    args->currChunk = &args->data;
}

void marchaller_destroy(upf_Arguments *args)
{
    assert(args != NULL);

    upf_ArgumentsChunk *chunk = args->data.next;
    upf_ArgumentsChunk *chunk2;
    while (chunk)
    {
       chunk2 = chunk->next;
       privateData->argsPool.free(chunk);
       chunk = chunk2;
    }
}

void marchaller_write(upf_Arguments *args, void *data, size_t len)
{
    assert(args != NULL);
    assert(len <= _UPF_ARGUMENTS_CHUNK_SIZE);
    
    if (args->chunkPos + len > _UPF_ARGUMENTS_CHUNK_SIZE)
    {
        if (args->currChunk->next == NULL)
        {
            args->currChunk->next = (upf_ArgumentsChunk*)privateData->argsPool.malloc();
            args->currChunk->next->next = NULL;
        }
        args->currChunk = args->currChunk->next;
        args->chunkPos = 0;
    }
    
    memcpy(args->currChunk->storage + args->chunkPos, data, len);
    args->chunkPos += len;
    args->size += len;
    args->totalPos += len;
}

void marchaller_read(upf_Arguments *args, void *data, size_t len)
{
    assert(args != NULL);
    assert(len <= _UPF_ARGUMENTS_CHUNK_SIZE);

    if (args->chunkPos + len > _UPF_ARGUMENTS_CHUNK_SIZE)
    {
        args->currChunk = args->currChunk->next;
        args->chunkPos = 0;
        assert(args->currChunk != NULL);
    }

    assert(args->totalPos + len <= args->size);

    memcpy(data, args->currChunk->storage + args->chunkPos, len);
    args->chunkPos += len;
    args->totalPos += len;
}



} }
