
#ifndef __UPF_SERVICES_H__
#define __UPF_SERVICES_H__

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "upf/upf.h"
#include "upf/IServiceManager.h"

#include <list>

namespace upf { namespace impl {

using namespace std;

class ServiceManager : public IServiceManager
{
public:
    ServiceManager();
    virtual ~ServiceManager();

    virtual bool bind(const string& name, IObject* obj, long permissions);
    virtual bool rebind(const string& name, IObject* obj);
    virtual bool unbind(const string& name);
    virtual Ptr<IObject> resolve(const string& name);
    virtual void addListener(const string& name, IServiceChangeListener* listener);
    
private:
    struct ServiceData
    {
        Ptr<IObject>                object;
        long                        permissions;
    };

    typedef StringHash<ServiceData> ServicesTbl;
    typedef list< Ptr<IServiceChangeListener> > Listeners;
    typedef StringHash<Listeners> ListenersTbl;

    bool doBind(ServicesTbl::iterator& service, IObject *object, long perm);

    ServicesTbl m_services;
    ListenersTbl m_listeners;

    UPF_DECLARE_CLASS(ServiceManager)
};


} } // end of namespace

#endif
