
#include <upf/upf.h>
#include <upf/ILog.h>

#include <string>
#include <iostream>

using namespace std;
using namespace upf;


class MyLog : public ILog
{
public:
    MyLog() {}
    virtual ~MyLog() {}
    
    void log(const string& origin, const LogType& type, const string& text)
    {
        cout << "MyLog: origin=" << origin << ", type=" << type << 
                ", text=\"" << text << "\"" << endl;
    }
    
    UPF_DECLARE_CLASS(MyLog)
};

UPF_IMPLEMENT_CLASS(MyLog)
{
    UPF_INTERFACE(upf::ILog)
}




void doLog(const char *logger)
{
    cout << "Using " << logger << ":" << endl << endl;
    Ptr<ILog> log = upf::getServiceManager()->resolve(SERVICE_LOG);

    log->log("test", ILog::LOG_INFO, "I'm busy");
    log->log("test", ILog::LOG_WARNING, "Achtung achtung...");
    log->log("test", ILog::LOG_ERROR, "An error occured");
    
    // force UPF error:
    upf::getServiceManager()->unbind(SERVICE_LOG);
    
    cout << endl;
}

void doTest()
{
    doLog("std logger");

    Ptr<ILog> mylog = upf::create("MyLog");
    upf::getServiceManager()->rebind(SERVICE_LOG, mylog);
    
    doLog("my logger");
}


int main()
{
    upf::init();
    UPF_REGISTER_CLASS(MyLog);
    doTest();
    upf::done();
}
