
#include <upf/upf.h>

#include <string>
#include <iostream>

using namespace std;
using namespace upf;

#include "utilities.h"

void enumProps(IObject *obj)
{
    Ptr<IManager> mng = upf::getManager();
    upf::CID cid = obj->getClassID();
    Ptr<IClassInfo> ci = mng->getClassInfo(cid);

    cout << "Class ";
    writeCID(cout, cid) << " has following properties:" << endl;
    IClassInfo::Properties props = ci->getProperties();
    for (IClassInfo::Properties::iterator i = props.begin(); i != props.end(); i++)
    {
        cout << "    " << i->name << "=" << i->value << endl;
    }
    cout << " value of 'Description' is '" << ci->getProperty("Description") << "'" << endl;
    cout << " value of 'Author' is '" << ci->getProperty("Author") << "'" << endl;
}


void doTest()
{
    Ptr<IManager> obj = upf::getManager();
    enumProps(obj);
    enumProps(obj->getClassInfo(obj->getClassID()));
}

int main()
{
    upf::init();
    doTest();
    upf::done();
}
