
#include <iostream>
#include <stdio.h>

inline ostream& operator<<(ostream& stream, const upf::IID& iid)
{
    char buf[6+32+10+1];
    sprintf(buf, "IID:%08x%08x%08x%08x/%i.%i",
            iid.data1, iid.data2, iid.data3, iid.data4,
            iid.version_major, iid.version_minor);
    Ptr<IManager> mng = upf::getManager();
    Ptr<IInterfaceInfo> info = mng->getInterfaceInfo(iid);
    return stream << buf << " [" << info->getName() << "]";
}



inline ostream& writeCID(ostream& stream, upf::CID cid)
{
    char buf[8+1];
    sprintf(buf, "%08x", cid);
    stream << "CID:" << buf << 
              " [" << upf::getManager()->getClassInfo(cid)->getName() << "]";
    return stream;
}



inline void enumImpl(const upf::IID& iid)
{
    Ptr<IManager> mng = upf::getManager();

    CIDsList cis = mng->enumInterfaceImplementations(iid);

    cout << "Following classes implement " << iid << ":" << endl;
    for (CIDsList::iterator i = cis.begin(); i != cis.end(); i++)
    {
        cout << "    ";
        writeCID(cout, *i) << endl;
    }    
}
