
%define        ver       0.1

Name:          upf
Version:       0.1.6
Release:       1
Source:        %{name}-%{version}.tar.bz2

Prefix:        /usr
Summary:       Universal Plugins Framework
License:       MIT
Group:         Development/Libraries
URL:           http://upf.sourceforge.net
Packager:      Vaclav Slavik <vaclav.slavik@matfyz.cz>
BuildRequires: python-devel

BuildRoot:     /var/tmp/%{name}-%{version}-root

%description
Universal Plugins Framework.

%package devel
Summary:       Universal Plugins Framework
Group:         Development/Libraries
Requires:      upf = %{version}
Requires:      pkgconfig
Requires:      python >= 2.2

%description devel
Header files and tools for Universal Plugins Framework.

%package python
Summary:       Python support for Universal Plugins Framework
Group:         Development/Libraries
Requires:      upf = %{version}
Requires:      python >= 2.2

%description python
Python support for for Universal Plugins Framework.


%prep
%setup -q

%build
CFLAGS="%{optflags}" CXXFLAGS="%{optflags}" ./configure --prefix=%{prefix}
%make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT


%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%defattr(-,root,root)
%doc NEWS README TODO AUTHORS
%{_libdir}/libupf.so.*
%{_libdir}/libupf_impl-*.so
%dir %{_libdir}/upf/
%dir %{_libdir}/upf/%{ver}
%dir %{_libdir}/upf/%{ver}/loaders

%files devel
%defattr(-,root,root)
%doc doc/*.txt doc/html
%{_bindir}/*
%dir %{_libdir}/upf/tools
%{_libdir}/upf/tools/*
%dir %{_includedir}/upf
%{_includedir}/upf/*
%{_libdir}/pkgconfig/*
%{_libdir}/libupf.so
%dir %{_datadir}/idl/upf
%{_datadir}/idl/upf/*

%files python
%defattr(-,root,root)
%dir %{_libdir}/upf/%{ver}/loaders/python-loader*.so
%dir %{_libdir}/python*/*/upf
%dir %{_libdir}/python*/*/upf/*
